
//  Kalentereita.java  Copyright (c) 2006 Kari Laitinen

//  http://www.naturalprogramming.com

//  2006-03-05  Tiedosto luotu.
//  2006-03-05  Viimeisin muutos.

//  Knnksen aikana tiedostojen Paivamaara.java ja PaivienEtaisyys.java
//  tulee olla samassa hakemistossa (kansiossa) tmn ohjelman kanssa.

class  SuomalainenKalenteri
{
   protected  int  tama_kuukausi ;
   protected  int  tama_vuosi ;

   protected  String[]  kuukausien_nimet ;
   protected  String    viikon_kuvaus ;

   public SuomalainenKalenteri() {}

   public SuomalainenKalenteri( int annettu_kuukausi, int annettu_vuosi )
   {
      String[]  suomalaiset_kuukausien_nimet  =  

         { "Tammikuu", "Helmikuu", "Maaliskuu", "Huhtikuu",
           "Toukokuu", "Kesakuu",  "Heinakuu",  "Elokuu",
           "Syyskuu",  "Lokakuu",  "Marraskuu", "Joulukuu" } ;

      String  suomalainen_viikon_kuvaus  =

          "Viikko   Ma   Ti   Ke   To   Pe   La   Su" ;

      kuukausien_nimet   =  suomalaiset_kuukausien_nimet ;

      viikon_kuvaus  =  suomalainen_viikon_kuvaus ;

      tama_kuukausi  =  annettu_kuukausi ;
      tama_vuosi     =  annettu_vuosi  ;
   }


   public void tulosta()
   {
      Paivamaara  paiva_tassa_kuussa  = 
                     new  Paivamaara( 1, tama_kuukausi, tama_vuosi ) ;

      int viikonpaivan_indeksi   =  0 ;
      int ensimmaisen_paivan_viikonpaiva  =
                          paiva_tassa_kuussa.viikonpaivan_indeksi() ;

      System.out.print(
            "\n\n   "  +  kuukausien_nimet[ tama_kuukausi - 1 ]
         +  "  "  +  tama_vuosi  +  "\n\n"  +  viikon_kuvaus   +  "\n\n"  ) ;

      System.out.printf( "%4d  ",  paiva_tassa_kuussa.laske_viikkonumero() ) ; 

      //  Ensimmainen kuukauden viikko on usein epataydellinen viikko,
      //  eli viikon alkupaivat kuuluvat edelliseen kuukauteen.
      //  Edelliseen kuukauteen kuuluvien paivien tilalle
      //  tulostetaan valilyonteja.

      while ( viikonpaivan_indeksi  !=  ensimmaisen_paivan_viikonpaiva )
      {
         System.out.print( "     " )  ;
         viikonpaivan_indeksi  ++ ;
      }

      while ( tama_kuukausi  ==  paiva_tassa_kuussa.kuukausi() )
      {
         if ( viikonpaivan_indeksi  >=  7 )
         {
            System.out.printf( "\n%4d  ", 
                               paiva_tassa_kuussa.laske_viikkonumero() ) ;

            viikonpaivan_indeksi  =  0 ;
         }

         System.out.printf( "%5d", paiva_tassa_kuussa.paiva() ) ;

         paiva_tassa_kuussa.kasvata() ;

         viikonpaivan_indeksi  ++  ;
      }

      System.out.print( "\n" ) ;
   }
}



class  EspanjalainenKalenteri  extends  SuomalainenKalenteri
{
   public EspanjalainenKalenteri( int annettu_kuukausi, int annettu_vuosi )
   {
      String[]  espanjalaiset_kuukausien_nimet  =

         { "Enero", "Febrero", "Marzo", "Abril",
           "Mayo", "Junio", "Julio", "Agosto",
           "Septiembre", "Octubre", "Noviembre", "Deciembre" } ;

      String   espanjalainen_viikon_kuvaus  =

           "Semana  Lun  Mar  Mie  Jue  Vie  Sab  Dom" ;

      kuukausien_nimet  =  espanjalaiset_kuukausien_nimet ;
      viikon_kuvaus     =  espanjalainen_viikon_kuvaus ;

      tama_kuukausi  =  annettu_kuukausi ;
      tama_vuosi     =  annettu_vuosi  ;
   }
}


class  Kalentereita
{
   public static void main( String[] ei_kaytossa )
   {
      SuomalainenKalenteri  eras_suomalainen_kalenteri  =
                                 new  SuomalainenKalenteri( 2, 2008 ) ;

      eras_suomalainen_kalenteri.tulosta() ;

      EspanjalainenKalenteri  eras_espanjalainen_kalenteri  =
                                  new  EspanjalainenKalenteri( 5, 2012 ) ;

      eras_espanjalainen_kalenteri.tulosta() ;
   }
}


